/*
 * emmaregs.h - EMMA Register ADDRESS
 */

#ifndef _EMMAREG_H_
#define _EMMAREG_H_

/*****************************************************************************
 * Register offset addresses
 ****************************************************************************/

/* BHIF */
#define BHIF_VERSION_OFS			0x000000
#define BHIF_GENERATION_OFS			0x000004
#define BHIF_STRAP_0_OFS			0x000010
#define BHIF_STRAP_WRITE_0_OFS			0x000020
#define BHIF_AVSWITCH_OFS			0x000024
#define BHIF_ALTERNATE0_OFS			0x000028
#define BHIF_ALTERNATE1_OFS			0x00002c
#define BHIF_MAIN_INT_ST_0_OFS			0x000030
#define BHIF_MAIN_INT_ST_1_OFS			0x000034
#define BHIF_MAIN_INT_ST_2_OFS			0x000038
#define BHIF_MAIN_INT0_EN_0_OFS			0x000040
#define BHIF_MAIN_INT0_EN_1_OFS			0x000044
#define BHIF_MAIN_INT0_EN_2_OFS			0x000048
#define BHIF_MAIN_INT1_EN_0_OFS			0x000050
#define BHIF_MAIN_INT1_EN_1_OFS			0x000054
#define BHIF_MAIN_INT1_EN_2_OFS			0x000058
#define BHIF_MAIN_NMI_ST_OFS			0x000060
#define BHIF_MAIN_NMI_EN_OFS			0x000064
#define BHIF_MAIN_RESET_OFS			0x0000b0
#define BHIF_MAIN_CTRL_OFS			0x0000b4
#define BHIF_EXCEPT_VECT_BASE_ADDRESS_OFS	0x0000c0
#define BHIF_MAIN_OFFSET_ADDRESS_OFS		0x0000c4
#define BHIF_MAIN_PADR_EN_OFS			0x000070
#define BHIF_MAIN_PADR1_BASE_OFS		0x000080
#define BHIF_MAIN_PADR1_MASK_OFS		0x000084
#define BHIF_MAIN_PADR1_TARGET_OFS		0x000088
#define BHIF_MAIN_PADR2_BASE_OFS		0x000090
#define BHIF_MAIN_PADR2_MASK_OFS		0x000094
#define BHIF_MAIN_PADR2_TARGET_OFS		0x000098
#define BHIF_SUB_PADR_EN_OFS			0x000140
#define BHIF_SUB_PADR0_MASK_OFS			0x000144
#define BHIF_SUB_PADR0_TARGET_OFS		0x000148
#define BHIF_SUB_PADR1_BASE_OFS			0x000150
#define BHIF_SUB_PADR1_MASK_OFS			0x000154
#define BHIF_SUB_PADR1_TARGET_OFS		0x000158
#define BHIF_SUB_PADR2_BASE_OFS			0x000160
#define BHIF_SUB_PADR2_MASK_OFS			0x000164
#define BHIF_SUB_PADR2_TARGET_OFS		0x000168
#if defined(CONFIG_EMMA3SEP)
#define BHIF_DVBTC_CTRL_0_OFS			0x0003e0
#define BHIF_DVBTC_CTRL_1_OFS			0x0003e4
#define BHIF_DVBTC_CTRL_2_OFS			0x0003e8
#endif

/* BROI */
#define BROI_ROM_MODE_OFS			0x000000
#define BROI_ROM_ACCESS_MODE_OFS		0x000004
#define BROI_ROMIF_MODE_OFS			0x000008

#define NAND_ROM_COMMAND_OFS			0x000010
#define NAND_ROM_ADDR1_OFS			0x000014
#define NAND_ROM_ADDR2_OFS			0x000018
#define NAND_ROM_STATUS_OFS			0x000020
#define NAND_ROM_SEQ_STATUS_OFS			0x000024
#define NAND_ROM_INTERRUPT_OFS			0x000028
#define NAND_ROM_INTERRUPT_ENABLE_OFS		0x00002c
#define NAND_ROM_CONTROL3_OFS			0x000030
#define NAND_ROM_CONTROL6_OFS			0x00003c
#define NAND_ROM_ECC_RESULT_OFS			0x000070
#define NAND_ROM_PROGRAM_STATUS_OFS		0x0001B0

#define SERIAL_ROM_ACCESS_MODE_OFS		0x00005c
#define SERIAL_ROM_CONTROL_OFS			0x000060
#define SERIAL_ROM_ADDRESS_OFS			0x000064
#define SERIAL_ROM_DATA_LENGTH_OFS		0x000068
#define SERIAL_ROM_DATA_COUNT_OFS		0x00006c

/* FTOP */
#define FLIP_REGBASE_OFS			0x000100
#define FLIP_M0_CTR_OFS				0x000000
#define FLIP_S_CTR_OFS				0x000014
#define FLIP_RESET_OFS				0x000018
#define FLIP_MHIFBUS_STA_OFS			0x00001c
#define FLIP_USB_CTR_OFS			0x000020
#define FLIP_USB_PREFETCH_OFS			0x000028
#define OHCI_CONFBASE_OFS			0x000200
#define EHCI_CONFBASE_OFS			0x000500
#define EHCI_OPBASE_OFS				0x000f00

/* PTOP */
#define PBRD_RESET_OFS				0x000000
#define PBRD_INTENABLE_MAIN_OFS			0x000010
#define PBRD_INTENABLE_SUB_OFS			0x000014
#define PTOP_PIIC0_BASE_OFS			0x007000
#define PTOP_PIIC1_BASE_OFS			0x008000
#define PTOP_PIIC2_BASE_OFS			0x009000

/* CTOP */
#define CHIF_PERICLK_SEL_OFS			0x0001b4

/* MIF */
#if defined(CONFIG_EMMA3SEP) || defined(CONFIG_EMMA3SL2LP)
#define MIF_SOFT_RST_OFS			0x000000
#define MIF_CONFIG_OFS				0x000004
#define MIF_INIT_OFS				0x000008
#define MIF_REFCNT_OFS				0x00000c
#define MIF_CONFIG2_OFS				0x000010
#define MIF_CONFIG3_OFS				0x000014
#define MIF_ZQCCNT_OFS				0x000060
#define MIF_DLIF_CTRL_OFS			0x0000a0
#define MIF_DLIF_DATA_OFS			0x0000a4
#define MIF_DLIF_RDATA_OFS			0x0000a8
#define MIF_DLIF_RSTB_OFS			0x0000ac
#define MIF_RSTB_OFS				0x0000e0
#define MIF_CLKDISABLE_OFS			0x0000e4
#define MIF_STATUS_OFS				0x0000e8
#define MIF_INITCMP_OFS				0x0000ec
#define MIF_DDRRSTB_OFS				0x0000f4
#define MIF_BYTEDISABLE_OFS			0x0000f8

#elif defined(CONFIG_EMMA3SLx)
#define MIF_SOFT_RST_OFS			0x000000
#define MIF_CONFIG_OFS				0x000004
#define MIF_INIT_OFS				0x000008
#define MIF_REFCNT_OFS				0x00000c
#define MIF_CONFIG2_OFS				0x000010
#define MIF_CONFIG3_OFS				0x000014
#define MIF_IOLHSTAT_OFS			0x0000b0
#define MIF_IENSTART_OFS			0x0000c0
#define MIF_IENCTRL_OFS				0x0000c4
#define MIF_IENCTRL2_OFS			0x0000c8
#define MIF_IENSTAT_OFS				0x0000cc
#define MIF_RSTB_OFS				0x0000e0
#define MIF_ODTSW_OFS				0x0000e4
#define MIF_IOLHRSTB_OFS			0x0000e8
#define MIF_IOLHCTRL_OFS			0x0000ec
#define MIF_DLLSTBY_OFS				0x0000f0
#define MIF_DLLCTRL_OFS				0x0000f4
#define MIF_DLLOFSTW_OFS			0x0000f8
#define MIF_DLLOFSTR_OFS			0x0000fc
#endif

/* ZPIO */
#if defined(CONFIG_EMMA3SEP)
#define ZPIO_DATA0_OFS				0x000000
#define ZPIO_DATA1_OFS				0x000004
#define ZPIO_MASK0_OFS				0x000018
#define ZPIO_MASK1_OFS				0x00001c
#define ZPIO_DIR0_OFS				0x000030
#define ZPIO_DIR1_OFS				0x000034
#endif

/*****************************************************************************
 * Register addresses
 ****************************************************************************/

/* BHIF */
#define BHIF_VERSION			KSEG1ADDR(BHIF_BASE + BHIF_VERSION_OFS)
#define BHIF_GENERATION			KSEG1ADDR(BHIF_BASE + BHIF_GENERATION_OFS)
#define BHIF_STRAP_0			KSEG1ADDR(BHIF_BASE + BHIF_STRAP_0_OFS)
#define BHIF_AVSWITCH			KSEG1ADDR(BHIF_BASE + BHIF_AVSWITCH_OFS)
#define BHIF_ALTERNATE0			KSEG1ADDR(BHIF_BASE + BHIF_ALTERNATE0_OFS)
#define BHIF_ALTERNATE1			KSEG1ADDR(BHIF_BASE + BHIF_ALTERNATE1_OFS)
#define BHIF_EXCEPT_VECT_BASE_ADDRESS	KSEG1ADDR(BHIF_BASE + BHIF_EXCEPT_VECT_BASE_ADDRESS_OFS)
#define BHIF_MAIN_PADR_EN		KSEG1ADDR(BHIF_BASE + BHIF_MAIN_PADR_EN_OFS)
#define BHIF_MAIN_PADR1_BASE		KSEG1ADDR(BHIF_BASE + BHIF_MAIN_PADR1_BASE_OFS)
#define BHIF_MAIN_PADR1_MASK		KSEG1ADDR(BHIF_BASE + BHIF_MAIN_PADR1_MASK_OFS)
#define BHIF_MAIN_PADR1_TARGET		KSEG1ADDR(BHIF_BASE + BHIF_MAIN_PADR1_TARGET_OFS)
#define BHIF_MAIN_PADR2_BASE		KSEG1ADDR(BHIF_BASE + BHIF_MAIN_PADR2_BASE_OFS)
#define BHIF_MAIN_PADR2_MASK		KSEG1ADDR(BHIF_BASE + BHIF_MAIN_PADR2_MASK_OFS)
#define BHIF_MAIN_PADR2_TARGET		KSEG1ADDR(BHIF_BASE + BHIF_MAIN_PADR2_TARGET_OFS)
#define BHIF_SUB_PADR_EN		KSEG1ADDR(BHIF_BASE + BHIF_SUB_PADR_EN_OFS)
#define BHIF_SUB_PADR0_MASK		KSEG1ADDR(BHIF_BASE + BHIF_SUB_PADR0_MASK_OFS)
#define BHIF_SUB_PADR0_TARGET		KSEG1ADDR(BHIF_BASE + BHIF_SUB_PADR0_TARGET_OFS)
#define BHIF_SUB_PADR1_BASE		KSEG1ADDR(BHIF_BASE + BHIF_SUB_PADR1_BASE_OFS)
#define BHIF_SUB_PADR1_MASK		KSEG1ADDR(BHIF_BASE + BHIF_SUB_PADR1_MASK_OFS)
#define BHIF_SUB_PADR1_TARGET		KSEG1ADDR(BHIF_BASE + BHIF_SUB_PADR1_TARGET_OFS)
#define BHIF_SUB_PADR2_BASE		KSEG1ADDR(BHIF_BASE + BHIF_SUB_PADR2_BASE_OFS)
#define BHIF_SUB_PADR2_MASK		KSEG1ADDR(BHIF_BASE + BHIF_SUB_PADR2_MASK_OFS)
#define BHIF_SUB_PADR2_TARGET		KSEG1ADDR(BHIF_BASE + BHIF_SUB_PADR2_TARGET_OFS)
#if defined(CONFIG_EMMA3SEP)
#define BHIF_DVBTC_CTRL_0		KSEG1ADDR(BHIF_BASE + BHIF_DVBTC_CTRL_0_OFS)
#define BHIF_DVBTC_CTRL_1		KSEG1ADDR(BHIF_BASE + BHIF_DVBTC_CTRL_1_OFS)
#define BHIF_DVBTC_CTRL_2		KSEG1ADDR(BHIF_BASE + BHIF_DVBTC_CTRL_2_OFS)
#endif

/* BROI */
#define BROI_ROM_MODE			KSEG1ADDR(BROI_BASE + BROI_ROM_MODE_OFS)
#define BROI_ROM_ACCESS_MODE		KSEG1ADDR(BROI_BASE + BROI_ROM_ACCESS_MODE_OFS)
#define BROI_ROMIF_MODE			KSEG1ADDR(BROI_BASE + BROI_ROMIF_MODE_OFS)

#define NAND_ROM_COMMAND		KSEG1ADDR(BROI_BASE + NAND_ROM_COMMAND_OFS)
#define NAND_ROM_ADDR1			KSEG1ADDR(BROI_BASE + NAND_ROM_ADDR1_OFS)
#define NAND_ROM_ADDR2			KSEG1ADDR(BROI_BASE + NAND_ROM_ADDR2_OFS)
#define NAND_ROM_STATUS			KSEG1ADDR(BROI_BASE + NAND_ROM_STATUS_OFS)
#define NAND_ROM_SEQ_STATUS		KSEG1ADDR(BROI_BASE + NAND_ROM_SEQ_STATUS_OFS)
#define NAND_ROM_INTERRUPT		KSEG1ADDR(BROI_BASE + NAND_ROM_INTERRUPT_OFS)
#define NAND_ROM_INTERRUPT_ENABLE	KSEG1ADDR(BROI_BASE + NAND_ROM_INTERRUPT_ENABLE_OFS)
#define NAND_ROM_CONTROL3		KSEG1ADDR(BROI_BASE + NAND_ROM_CONTROL3_OFS)
#define NAND_ROM_CONTROL6		KSEG1ADDR(BROI_BASE + NAND_ROM_CONTROL6_OFS)
#define NAND_ROM_ECC_RESULT		KSEG1ADDR(BROI_BASE + NAND_ROM_ECC_RESULT_OFS)
#define NAND_ROM_PROGRAM_STATUS		KSEG1ADDR(BROI_BASE + NAND_ROM_PROGRAM_STATUS_OFS)

#define SERIAL_ROM_ACCESS_MODE		KSEG1ADDR(BROI_BASE + SERIAL_ROM_ACCESS_MODE_OFS)
#define SERIAL_ROM_CONTROL		KSEG1ADDR(BROI_BASE + SERIAL_ROM_CONTROL_OFS)
#define SERIAL_ROM_ADDRESS		KSEG1ADDR(BROI_BASE + SERIAL_ROM_ADDRESS_OFS)
#define SERIAL_ROM_DATA_LENGTH		KSEG1ADDR(BROI_BASE + SERIAL_ROM_DATA_LENGTH_OFS)
#define SERIAL_ROM_DATA_COUNT		KSEG1ADDR(BROI_BASE + SERIAL_ROM_DATA_COUNT_OFS)

/* FTOP */
#define FLIP_REGBASE			KSEG1ADDR(PCI_BASE + FLIP_REGBASE_OFS)
#define FLIP_M0_CTR			KSEG1ADDR(FLIP_REGBASE + FLIP_M0_CTR_OFS)
#define FLIP_S_CTR			KSEG1ADDR(FLIP_REGBASE + FLIP_S_CTR_OFS)
#define FLIP_RESET			KSEG1ADDR(FLIP_REGBASE + FLIP_RESET_OFS)
#define FLIP_MHIFBUS_STA		KSEG1ADDR(FLIP_REGBASE + FLIP_MHIFBUS_STA_OFS)
#define FLIP_USB_CTR			KSEG1ADDR(FLIP_REGBASE + FLIP_USB_CTR_OFS)
#define FLIP_USB_PREFETCH		KSEG1ADDR(FLIP_REGBASE + FLIP_USB_PREFETCH_OFS)

#define OHCI_CONFBASE			KSEG1ADDR(PCI_BASE + OHCI_CONFBASE_OFS)
#define EHCI_CONFBASE			KSEG1ADDR(PCI_BASE + EHCI_CONFBASE_OFS)
#define EHCI_OPBASE			KSEG1ADDR(PCI_BASE + EHCI_OPBASE_OFS)

/* PTOP */
#define PBRD_RESET			KSEG1ADDR(PBRD_BASE + PBRD_RESET_OFS)
#define PBRD_INTENABLE_MAIN		KSEG1ADDR(PBRD_BASE + PBRD_INTENABLE_MAIN_OFS)
#define PBRD_INTENABLE_SUB		KSEG1ADDR(PBRD_BASE + PBRD_INTENABLE_SUB_OFS)

#define PIIC0_BASE			KSEG1ADDR(PBRD_BASE + PTOP_PIIC0_BASE_OFS)
#define PIIC1_BASE			KSEG1ADDR(PBRD_BASE + PTOP_PIIC1_BASE_OFS)
#define PIIC2_BASE			KSEG1ADDR(PBRD_BASE + PTOP_PIIC2_BASE_OFS)

/* CTOP */
#define CHIF_PERICLK_SEL		KSEG1ADDR(CLK_BASE + CHIF_PERICLK_SEL_OFS)

/* MIF */
#if defined(CONFIG_EMMA3SEP) || defined(CONFIG_EMMA3SL2LP)
#define MIF_SOFT_RST			KSEG1ADDR(MIF_BASE + MIF_SOFT_RST_OFS)
#define MIF_CONFIG			KSEG1ADDR(MIF_BASE + MIF_CONFIG_OFS)
#define MIF_INIT			KSEG1ADDR(MIF_BASE + MIF_INIT_OFS)
#define MIF_REFCNT			KSEG1ADDR(MIF_BASE + MIF_REFCNT_OFS)
#define MIF_CONFIG2			KSEG1ADDR(MIF_BASE + MIF_CONFIG2_OFS)
#define MIF_CONFIG3			KSEG1ADDR(MIF_BASE + MIF_CONFIG3_OFS)
#define MIF_ZQCCNT			KSEG1ADDR(MIF_BASE + MIF_ZQCCNT_OFS)
#define MIF_DLIF_CTRL			KSEG1ADDR(MIF_BASE + MIF_DLIF_CTRL_OFS)
#define MIF_DLIF_DATA			KSEG1ADDR(MIF_BASE + MIF_DLIF_DATA_OFS)
#define MIF_DLIF_RDATA			KSEG1ADDR(MIF_BASE + MIF_DLIF_RDATA_OFS)
#define MIF_DLIF_RSTB			KSEG1ADDR(MIF_BASE + MIF_DLIF_RSTB_OFS)
#define MIF_RSTB			KSEG1ADDR(MIF_BASE + MIF_RSTB_OFS)
#define MIF_CLKDISABLE			KSEG1ADDR(MIF_BASE + MIF_CLKDISABLE_OFS)
#define MIF_STATUS			KSEG1ADDR(MIF_BASE + MIF_STATUS_OFS)
#define MIF_INITCMP			KSEG1ADDR(MIF_BASE + MIF_INITCMP_OFS)
#define MIF_DDRRSTB			KSEG1ADDR(MIF_BASE + MIF_DDRRSTB_OFS)
#define MIF_BYTEDISABLE			KSEG1ADDR(MIF_BASE + MIF_BYTEDISABLE_OFS)

#elif defined(CONFIG_EMMA3SLx)
#define MIF_SOFT_RST			KSEG1ADDR(MIF_BASE + MIF_SOFT_RST_OFS)
#define MIF_CONFIG			KSEG1ADDR(MIF_BASE + MIF_CONFIG_OFS)
#define MIF_INIT			KSEG1ADDR(MIF_BASE + MIF_INIT_OFS)
#define MIF_REFCNT			KSEG1ADDR(MIF_BASE + MIF_REFCNT_OFS)
#define MIF_CONFIG2			KSEG1ADDR(MIF_BASE + MIF_CONFIG2_OFS)
#define MIF_CONFIG3			KSEG1ADDR(MIF_BASE + MIF_CONFIG3_OFS)
#define MIF_IOLHSTAT			KSEG1ADDR(MIF_BASE + MIF_IOLHSTAT_OFS)
#define MIF_IENSTART			KSEG1ADDR(MIF_BASE + MIF_IENSTART_OFS)
#define MIF_IENCTRL			KSEG1ADDR(MIF_BASE + MIF_IENCTRL_OFS)
#define MIF_IENCTRL2			KSEG1ADDR(MIF_BASE + MIF_IENCTRL2_OFS)
#define MIF_IENSTAT			KSEG1ADDR(MIF_BASE + MIF_IENSTAT_OFS)
#define MIF_RSTB			KSEG1ADDR(MIF_BASE + MIF_RSTB_OFS)
#define MIF_ODTSW			KSEG1ADDR(MIF_BASE + MIF_ODTSW_OFS)
#define MIF_IOLHRSTB			KSEG1ADDR(MIF_BASE + MIF_IOLHRSTB_OFS)
#define MIF_IOLHCTRL			KSEG1ADDR(MIF_BASE + MIF_IOLHCTRL_OFS)
#define MIF_DLLSTBY			KSEG1ADDR(MIF_BASE + MIF_DLLSTBY_OFS)
#define MIF_DLLCTRL			KSEG1ADDR(MIF_BASE + MIF_DLLCTRL_OFS)
#define MIF_DLLOFSTW			KSEG1ADDR(MIF_BASE + MIF_DLLOFSTW_OFS)
#define MIF_DLLOFSTR			KSEG1ADDR(MIF_BASE + MIF_DLLOFSTR_OFS)
#endif

/* ZPIO */
#if defined(CONFIG_EMMA3SEP)
#define ZPIO_DATA0			KSEG1ADDR(ZPIO_BASE + ZPIO_DATA0_OFS)
#define ZPIO_DATA1			KSEG1ADDR(ZPIO_BASE + ZPIO_DATA1_OFS)
#define ZPIO_MASK0			KSEG1ADDR(ZPIO_BASE + ZPIO_MASK0_OFS)
#define ZPIO_MASK1			KSEG1ADDR(ZPIO_BASE + ZPIO_MASK1_OFS)
#define ZPIO_DIR0			KSEG1ADDR(ZPIO_BASE + ZPIO_DIR0_OFS)
#define ZPIO_DIR1			KSEG1ADDR(ZPIO_BASE + ZPIO_DIR1_OFS)
#endif

#endif /* _EMMAREG_H_ */


