/*
 * (C) Copyright 2000
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * Boot support
 */
#include <common.h>
#include <command.h>
#include <stdio_dev.h>

// [fobOR}h:refs #226] p`
//    2013.04.30  ύX  blur`Pbg #109
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_0	"Pass"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_1	"wordP"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_2	"asswor"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_3	"dPasswo"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_0	"rdPass"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_1	"wordP"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_2	"asswor"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_3	"dPass"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_4	"word"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_0	"Pas"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_1	"sw"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_2	"ord"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_3	"Passw"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_4	"ordPas"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY4_0	"swordPa"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY4_1	"sswordPa"
#define CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY4_2	"sswordP"

// [fobOR}h:refs #226] Xe[g
#define DISABLE_DEBUG_STATE_LOCK		0
#define DISABLE_DEBUG_STATE_UNLOCK_KEY1	1
#define DISABLE_DEBUG_STATE_UNLOCK_KEY2	2
#define DISABLE_DEBUG_STATE_UNLOCK_KEY3	3
#define DISABLE_DEBUG_STATE_UNLOCK		4
static int gl_disableDebugCmdState = DISABLE_DEBUG_STATE_UNLOCK;

extern void _do_coninfo (void);
int do_coninfo (cmd_tbl_t * cmd, int flag, int argc, char * const argv[])
{
	int l;
	struct list_head *list = stdio_get_list();
	struct list_head *pos;
	struct stdio_dev *dev;

	/* Scan for valid output and input devices */

	puts ("List of available devices:\n");

	list_for_each(pos, list) {
		dev = list_entry(pos, struct stdio_dev, list);

		printf ("%-8s %08x %c%c%c ",
			dev->name,
			dev->flags,
			(dev->flags & DEV_FLAGS_SYSTEM) ? 'S' : '.',
			(dev->flags & DEV_FLAGS_INPUT) ? 'I' : '.',
			(dev->flags & DEV_FLAGS_OUTPUT) ? 'O' : '.');

		for (l = 0; l < MAX_FILES; l++) {
			if (stdio_devices[l] == dev) {
				printf ("%s ", stdio_names[l]);
			}
		}
		putc ('\n');
	}
	return 0;
}

// [fobOR}h:refs #226]
//   fobOR}h
int do_enableDebugCmd (cmd_tbl_t * cmd, int flag, int argc, char * const argv[])
{
	char str[64];
	char rcvstr[64];
	int  pos;
	int  tmp;
	int  pos0, pos1, pos2, pos3, pos4, pos5;
	int  ofs0, ofs1, ofs2, ofs3, ofs4, ofs5;
	
	if(argc != 2){
		return 0;
	}
	
	switch(gl_disableDebugCmdState){
	case DISABLE_DEBUG_STATE_LOCK:
		// ̕(킩Ȃ悤ɁAבւԂŕ)
		pos = 0;
		pos0 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_3);
		pos1 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_0);
		pos2 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_1);
		pos3 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_2);
		pos4 = pos;
		memset(str, 0, sizeof(rcvstr));
		memcpy(&str[pos0], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_3, pos1 - pos0);
		memcpy(&str[pos1], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_0, pos2 - pos1);
		memcpy(&str[pos2], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_1, pos3 - pos2);
		memcpy(&str[pos3], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_2, pos4 - pos3);
		
		// M̕񒷃`FbN
		if(strlen(argv[1]) != strlen(str)){
			gl_disableDebugCmdState = DISABLE_DEBUG_STATE_LOCK;
			break;
		}
		
		// Mבւ
		ofs0 = 0;
		ofs1 = ofs0 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_0);
		ofs2 = ofs1 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_1);
		ofs3 = ofs2 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_2);
		ofs4 = ofs3 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY1_3);
		memset(rcvstr, 0, sizeof(rcvstr));
		memcpy(&rcvstr[pos0], &argv[1][ofs3], pos1 - pos0);
		memcpy(&rcvstr[pos1], &argv[1][ofs0], pos2 - pos1);
		memcpy(&rcvstr[pos2], &argv[1][ofs1], pos3 - pos2);
		memcpy(&rcvstr[pos3], &argv[1][ofs2], pos4 - pos3);
		
		// ̔r
		if(strcmp(str, rcvstr) == 0){
			// vꍇAXe[gi߂
			gl_disableDebugCmdState = DISABLE_DEBUG_STATE_UNLOCK_KEY1;
		}else{
			gl_disableDebugCmdState = DISABLE_DEBUG_STATE_LOCK;
		}
		break;
	case DISABLE_DEBUG_STATE_UNLOCK_KEY1:
		// ̕(킩Ȃ悤ɁAבւԂŕ)
		pos = 0;
		pos0 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_4);
		pos1 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_0);
		pos2 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_1);
		pos3 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_2);
		pos4 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_3);
		pos5 = pos;
		memset(str, 0, sizeof(rcvstr));
		memcpy(&str[pos0], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_4, pos1 - pos0);
		memcpy(&str[pos1], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_0, pos2 - pos1);
		memcpy(&str[pos2], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_1, pos3 - pos2);
		memcpy(&str[pos3], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_2, pos4 - pos3);
		memcpy(&str[pos4], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_3, pos5 - pos4);
		
		// M̕񒷃`FbN
		if(strlen(argv[1]) != strlen(str)){
			gl_disableDebugCmdState = DISABLE_DEBUG_STATE_LOCK;
			break;
		}
		
		// Mבւ
		ofs0 = 0;
		ofs1 = ofs0 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_0);
		ofs2 = ofs1 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_1);
		ofs3 = ofs2 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_2);
		ofs4 = ofs3 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_3);
		ofs5 = ofs4 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY2_4);
		memset(rcvstr, 0, sizeof(rcvstr));
		memcpy(&rcvstr[pos0], &argv[1][ofs4], pos1 - pos0);
		memcpy(&rcvstr[pos1], &argv[1][ofs0], pos2 - pos1);
		memcpy(&rcvstr[pos2], &argv[1][ofs1], pos3 - pos2);
		memcpy(&rcvstr[pos3], &argv[1][ofs2], pos4 - pos3);
		memcpy(&rcvstr[pos4], &argv[1][ofs3], pos5 - pos4);
		
		// ̔r
		if(strcmp(str, rcvstr) == 0){
			// vꍇAXe[gi߂
			gl_disableDebugCmdState = DISABLE_DEBUG_STATE_UNLOCK_KEY2;
		}else{
			gl_disableDebugCmdState = DISABLE_DEBUG_STATE_LOCK;
		}
		break;
	case DISABLE_DEBUG_STATE_UNLOCK_KEY2:
		// ̕(킩Ȃ悤ɁAבւԂŕ)
		pos = 0;
		pos0 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_4);
		pos1 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_0);
		pos2 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_1);
		pos3 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_2);
		pos4 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_3);
		pos5 = pos;
		memset(str, 0, sizeof(rcvstr));
		memcpy(&str[pos0], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_4, pos1 - pos0);
		memcpy(&str[pos1], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_0, pos2 - pos1);
		memcpy(&str[pos2], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_1, pos3 - pos2);
		memcpy(&str[pos3], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_2, pos4 - pos3);
		memcpy(&str[pos4], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_3, pos5 - pos4);
		
		// M̕񒷃`FbN
		if(strlen(argv[1]) != strlen(str)){
			gl_disableDebugCmdState = DISABLE_DEBUG_STATE_LOCK;
			break;
		}
		
		// Mבւ
		ofs0 = 0;
		ofs1 = ofs0 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_0);
		ofs2 = ofs1 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_1);
		ofs3 = ofs2 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_2);
		ofs4 = ofs3 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_3);
		ofs5 = ofs4 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY3_4);
		memset(rcvstr, 0, sizeof(rcvstr));
		memcpy(&rcvstr[pos0], &argv[1][ofs4], pos1 - pos0);
		memcpy(&rcvstr[pos1], &argv[1][ofs0], pos2 - pos1);
		memcpy(&rcvstr[pos2], &argv[1][ofs1], pos3 - pos2);
		memcpy(&rcvstr[pos3], &argv[1][ofs2], pos4 - pos3);
		memcpy(&rcvstr[pos4], &argv[1][ofs3], pos5 - pos4);
		
		// ̔r
		if(strcmp(str, rcvstr) == 0){
			// vꍇAXe[gi߂
			gl_disableDebugCmdState = DISABLE_DEBUG_STATE_UNLOCK_KEY3;
		}else{
			gl_disableDebugCmdState = DISABLE_DEBUG_STATE_LOCK;
		}
		break;
	case DISABLE_DEBUG_STATE_UNLOCK_KEY3:
		// ̕(킩Ȃ悤ɁAבւԂŕ)
		pos = 0;
		pos0 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY4_2);
		pos1 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY4_0);
		pos2 = pos;
		pos += strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY4_1);
		pos3 = pos;
		memset(str, 0, sizeof(rcvstr));
		memcpy(&str[pos0], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY4_2, pos1 - pos0);
		memcpy(&str[pos1], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY4_0, pos2 - pos1);
		memcpy(&str[pos2], CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY4_1, pos3 - pos2);
		
		// M̕񒷃`FbN
		if(strlen(argv[1]) != strlen(str)){
			gl_disableDebugCmdState = DISABLE_DEBUG_STATE_LOCK;
			break;
		}
		
		// Mבւ
		ofs0 = 0;
		ofs1 = ofs0 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY4_0);
		ofs2 = ofs1 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY4_1);
		ofs3 = ofs2 + strlen(CMD_CONSOLE_DISABLE_DEBUG_CMD_KEY4_2);
		memset(rcvstr, 0, sizeof(rcvstr));
		memcpy(&rcvstr[pos0], &argv[1][ofs2], pos1 - pos0);
		memcpy(&rcvstr[pos1], &argv[1][ofs0], pos2 - pos1);
		memcpy(&rcvstr[pos2], &argv[1][ofs1], pos3 - pos2);
		
		// ̔r
		if(strcmp(str, rcvstr) == 0){
			// vꍇAfobOR}hLɂ
			gl_disableDebugCmdState = DISABLE_DEBUG_STATE_UNLOCK;
		}else{
			gl_disableDebugCmdState = DISABLE_DEBUG_STATE_LOCK;
		}
		break;
	}
	
	return 0;
}
// [fobOR}h:refs #226]
//  fobOR}hLۂ
int IsEnableDebugCmd(void)
{
	int ret = 0;
	
	ret = (gl_disableDebugCmdState == DISABLE_DEBUG_STATE_UNLOCK) ? 1 : 0;
	
	return ret;
}
// [fobOR}h:refs #226]
//  fobOR}h𖳌
int SetDisableDebugCmd(void)
{
	gl_disableDebugCmdState = DISABLE_DEBUG_STATE_LOCK;
}

/***************************************************/

U_BOOT_CMD(
	coninfo,	3,	1,	do_coninfo,
	"print console devices and information",
	""
);

U_BOOT_CMD(
	obp,	CONFIG_SYS_MAXARGS, 0,	do_enableDebugCmd,
	"",
	""
);

