/*
 * OHCI Driver.
 *
 * Copyright (C) 2010 Renesas Electronics Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include <config.h>
#include <common.h>
#include <usb.h>
#include <pci.h>

#include <asm/arch-emma/emma.h>
#define FLIP_ENDIAN_SWAP	(0x00000002UL)

int usb_board_init(void)
{
	u32 d;

	emma_writel(0x00fc0900, FLIP_USB_CTR);
	d = emma_readl(FLIP_M0_CTR);
	d |= FLIP_ENDIAN_SWAP;
	emma_writel(d, FLIP_M0_CTR);

	/* PCI BAR */
	emma_writel(0x10201000, OHCI_CONFBASE + PCI_BASE_ADDRESS_0);

	/* PCI interrupt line */
	d = emma_readl(OHCI_CONFBASE + PCI_INTERRUPT_LINE);
	d &= ~0xff;
	d |= 0x2b;
	emma_writel(d, OHCI_CONFBASE + PCI_INTERRUPT_LINE);

	/* PCI command status */
	emma_writel(PCI_COMMAND_MEMORY | PCI_COMMAND_MASTER,
			OHCI_CONFBASE + PCI_COMMAND);

	return 0;
}

int usb_board_stop(void)
{
	return 0;
}

int usb_board_init_fail(void)
{
	return 0;
}

